#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <sprite.h>
#include <mfsprite.h>
#include <stdio.h>
#include <dlfcn.h>

#include "xhtile.h"
#include "xhwin.h"
#include "sonic.h"

void (*__ljbad_MakeTiles)(XhedgehogWin *w);
void (*__ljbad_MakeSprites)(XhedgehogWin *w);
int (*__ljbad_GetTileStatus)(int f);

void *ZoneDllHandle;

char *ZoneTitle;

extern "C" {
  void MakeTiles(XhedgehogWin *w) {
    (*__ljbad_MakeTiles)(w);
  }
  void MakeSprites(XhedgehogWin *w) {
    (*__ljbad_MakeSprites)(w);
  }
  int GetTileStatus(int f) {
    (*__ljbad_GetTileStatus)(f);
  }
}

void LoadZone(char *zone_name) {
  fprintf(stderr,"\nLoading zone...\n");
  char *er;
  ZoneDllHandle = dlopen(zone_name,RTLD_LAZY);
  er = dlerror();
  if(er) {
    fprintf(stderr,"cannot open zone: %s, reason: %s\n",zone_name,er);
    exit(1);
  }
  __ljbad_MakeTiles = (dlsym(ZoneDllHandle,"MakeTiles"));
  er = dlerror();
  if(er) {
    fprintf(stderr,"cannot link zone: %s, reason: %s\n",zone_name,er);
    exit(1);
  }
  __ljbad_MakeSprites = (dlsym(ZoneDllHandle,"MakeSprites"));
  er = dlerror();
  if(er) {
    fprintf(stderr,"cannot link zone: %s, reason: %s\n",zone_name,er);
    exit(1);
  }
  __ljbad_GetTileStatus = (dlsym(ZoneDllHandle,"GetTileStatus"));
  er = dlerror();
  if(er) {
    fprintf(stderr,"cannot link zone: %s, reason: %s\n",zone_name,er);
    exit(1);
  }
  ZoneTitle = (char *)(dlsym(ZoneDllHandle,"DllZoneTitle"));
  er = dlerror();
  if(er) {
    fprintf(stderr,"cannot link zone: %s, reason: %s\n",zone_name,er);
    exit(1);
  }
  fprintf(stderr,"%s zone loaded.\n",ZoneTitle);
}

void UnloadZone() {
  printf("Unloading %s zone...\n",ZoneTitle);
  dlclose(ZoneDllHandle);
  __ljbad_MakeTiles = NULL;
  __ljbad_MakeSprites = NULL;
  __ljbad_GetTileStatus = NULL;
  ZoneTitle = NULL;
}

int main(void) {
  Display *dpy = XOpenDisplay(NULL);
  XAutoRepeatOff(dpy);
  fprintf(stderr,"Xhedgehog 0.2.0 - A Sonic-Like Game for X\n"
	         "Copyright (c) 1996,1997 by Jeff Read. All rights reserved.\n"
	         "This program comes with ABSOLUTELY NO WARRANTY; see the\n"
		 "file COPYING for details.\n");
  LoadZone("./test-bay.zone.so");
  XhedgehogWin *w = new XhedgehogWin(dpy);
  w->Run();
  w->KillSoundSrv();
  UnloadZone();
  XAutoRepeatOn(dpy);
  XCloseDisplay(dpy);
}
