class Shield;

class Sonic :  public MultiframeSprite {
  friend class XhedgehogWin;
protected:
  int dir;
  int flags;
  int keys;
  float accel,vel,maxvel;
  int slope;
  unsigned int rings;
  Sprite *LastSurf;
  Shield *sh;
public:
  void MoveSprite(float newx,float newy);
  void __MoveSprite(float newx,float newy);
  void RenderSprite(Drawable d);
  Sonic(XhedgehogWin *sw,float _x,float _y);
  void SetFlag(int f) {flags |= f;}
  void ClearFlag(int f) {flags &= (~f);}
  int GetFlag(int f) {return(flags & f);}
  virtual void KeyDown(int k); 
  virtual void KeyUp(int k);
  int GetKeyStatus(int k) {return(keys & k);}
  void SetStandShape();
  void SetWalkShape();
  void SetSpinShape();
  void SetRunShape();
  void SetSlideShape();
  void SetFallShape();
  void SetSquatShape();
  void SetLookupShape();
  void SetLookup2Shape();
  void SetJuiceShape();
  void IncreaseRings();
  void IncreaseRingsByTen();
  void InitializePosition();
  int SpriteHitTest2(Sprite *s);
  void StandSurf(Sprite *s);
  void Bounce();
  void OnHitTest(Sprite *s);
  void EnemyHit();
  void EnableShield();
  void DisableShield();
};

extern "C" {
  Sonic *CreateCharacter(XhedgehogWin *sw,float _x,float _y);
}

//Virtual keys.
#define RIGHTKEY 1
#define LEFTKEY 2
#define UPKEY 4
#define DOWNKEY 8
#define JUMPKEY 16

//Flags.
#define WALKFLAG 1
#define JUMPFLAG 2
#define ROLLFLAG 4
#define SLIDEFLAG 8
#define HITFLAG 16
#define JUICEFLAG 32
